﻿package  
{
	import flash.display.Sprite;
	
	/**
	 * ...
	 * @author ...
	 */
	public class DummyPuyo extends Sprite
	{
		internal var color:uint;		
		
		private var parentPuyo:Puyo;
		
		public function DummyPuyo(xi:uint, yi:uint, parentPuyo:Puyo) 
		{
			x = xi;
			y = yi;
			setOwnColor();			
			
			this.parentPuyo = parentPuyo;
		}

		private function setOwnColor():void {
	
			switch(Math.floor(Math.random() * 4)) {
				case 0:
					color = Puyo.YELLOW;
					break;
				case 1:
					color = Puyo.GREEN;
					break;
				case 2:
					color = Puyo.BLUE;
					break;
				case 3:
					color = Puyo.RED;
					break;					
			}
			
			graphics.lineStyle(1, 0xffffff);
			graphics.beginFill(color);
			graphics.drawCircle(0, 0, Puyo.RADIUS);
			graphics.endFill();
		}		
		
		internal function move(direction:uint):void {
			
			switch(direction) {
				case Puyo.RIGHT:
					x = 0;
					y = -2 * Puyo.RADIUS;
					break;
				case Puyo.LEFT:
					y = 2 * Puyo.RADIUS;
					x = 0;
					break;
				case Puyo.DOWN:
					x = 2 * Puyo.RADIUS;
					y = 0;
					break;					
				case Puyo.UP:
					x = -2 * Puyo.RADIUS;
					y = 0;
					break;					
			}
		}
		
		internal function isContactAll():Boolean {
			for each(var v:Puyo in PuyoStage.puyoList)
				if (isContact(v))
					return true;
					
			return false;
		}
		
		private function isContact(target:Puyo):Boolean {
			return Math.abs(y + parentPuyo.y - target.y) + Math.abs(x + parentPuyo.x - target.x) == 0;
		}		
		
	}	
}
