﻿package  
{
	import flash.display.Sprite;
	import flash.events.KeyboardEvent;
	import flash.events.TimerEvent;
	import flash.ui.Keyboard;
	import flash.utils.Timer;
	
	/**
	 * ...
	 * @author ...
	 */
	public class PuyoStage extends Sprite
	{		
		static internal const WIDTH:uint = 400;
		
		static internal var puyoList:Array;
		static internal var rensaTimer:Timer;
		

		public function PuyoStage() 
		{
			puyoList = new Array();
			cycle(null);
		}
		
		
		static internal function cycle(event:TimerEvent):void {
			new Puyo(200 - Puyo.RADIUS, 2 * Puyo.RADIUS);
		}

		
		static internal function newLink():void {
			
			for each(var v:Puyo in puyoList)
				v.pair = new Array();

			var tmp:Array = new Array();
			
			for each(v in puyoList) {
				for each(var target:Puyo in tmp)	
					if (v.isPuyo(target)) {

						v.pair.push(target);
						target.pair.push(v);
					}			
				
				tmp.push(v);
			}
		}

		static private function getTarget(chk:uint):Puyo {
			
			for each(var v:Puyo in puyoList)
				if (v.checked == chk)
					return v;
					
			return null;
		}
		
		static internal function erase():Boolean {

			for each(var v:Puyo in puyoList)
				v.checked = -1;
			
			var checked:int = 0;
			for each(v in puyoList) {
				if (v.getLinkNum(null, checked) > 3) {

					var target:Puyo;
					while ((target = getTarget(checked)) != null)
						target.remove();
											
					erase();
					return true;
				}			
				
				checked ++;
			}
						
			return false;
		}

		
		static internal function reNewState():void {

			newLink();

			if (erase()) {
				rensaTimer = new Timer(500, 1);
				rensaTimer.start();
				rensaTimer.addEventListener(TimerEvent.TIMER, rensa);
			}
				
			else {
				for each(var v:Puyo in puyoList) {
					do {
						v.move(Puyo.DOWN);
					} while (v.y < 700 && !v.isContactAll());
					v.move(Puyo.UP);
				}				
				cycle(null);		
			}
		}
		
		
		static internal function rensa(event:TimerEvent):void {

			for each(var v:Puyo in puyoList) {
				do {
					v.move(Puyo.DOWN);
				} while (v.y < 700 && !v.isContactAll());
				v.move(Puyo.UP);
			}
			
			rensaTimer.reset();
			reNewState();
		}
		
	}
	
}
